_G.AudioKillstreak = _G.AudioKillstreak or {}
AudioKillstreak.ModPath = ModPath
AudioKillstreak.SaveFile = SavePath .. "AudioKillstreak.txt"
AudioKillstreak.Settings = {}

function AudioKillstreak:Reset()
    self.Settings = {
        headshot_toggle = false,
        audio_killstreak_volume = 50,
        audio_killstreak_choice = 3
    }
end

function AudioKillstreak:Load()
    local file = io.open(self.SaveFile,"r")
    if file then
        for k, v in pairs(json.decode(file:read('*all')) or {}) do
            self.Settings[k]=v
        end
        file:close()
    else
        self:Reset()
    end
end

function AudioKillstreak:Save()
    local file = io.open( self.SaveFile, "w+" )
    if file then
        file:write( json.encode( self.Settings ) )
        file:close()
    end
end

AudioKillstreak:Load()

Hooks:Add("LocalizationManagerPostInit" , "LocalizationManagerPostInit_AudioKillstreak" , function( loc )
	loc:load_localization_file( AudioKillstreak.ModPath .. "loc/english.txt", false )
end )

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_AudioKillstreak", function( menu_manager )
    function MenuCallbackHandler:AudioKillstreakSave(item)
        AudioKillstreak:Save()
    end

    function MenuCallbackHandler:set_headshot_toggle(item)
        AudioKillstreak.Settings.headshot_toggle = item:value() == "on"
    end

    function MenuCallbackHandler:set_audio_killstreak_volume(item)
        AudioKillstreak.Settings.audio_killstreak_volume = tonumber(item:value())
    end
    function MenuCallbackHandler:set_audio_killstreak_choice(item)
        AudioKillstreak.Settings.audio_killstreak_choice = tonumber(item:value())
    end

    MenuHelper:LoadFromJsonFile( AudioKillstreak.ModPath .. "options.txt", AudioKillstreak, AudioKillstreak.Settings )
end )